import {filterParam} from './get';
import {getDatabase} from './getDB.web';
import {databaseConf, mergeDBName, possibleDBKeys} from './types';

export const getEntry = async <T2 extends databaseConf<T, any>, T>(
  schema: T2,
  key: possibleDBKeys,
  suffix?: string,
): Promise<null | T> => {
  const nameObj = {name: schema.details.name, suffix};
  const dbName = nameObj.name;

  const db = await getDatabase(nameObj);

  const tx = db.transaction(dbName, 'readonly');
  const store = tx.objectStore(dbName);

  return await store.get(key);
  //await store.put(value);
  //await tx.done;
};

export const getAllEntries = async <T2 extends databaseConf<T, any>, T>(
  schema: T2,
  filter?: filterParam,
  suffix?: string,
): Promise<null | T[]> => {
  const nameObj = {name: schema.details.name, suffix};
  const dbName = nameObj.name;

  console.log(dbName);

  const db = await getDatabase(nameObj);

  const tx = db.transaction(dbName, 'readonly');
  const store = tx.objectStore(dbName);

  return await store.getAll();
  //await store.put(value);
  //await tx.done;
};
